select
state_counts.creator_id,
state_counts.gender,
((sum(state_counts.merged) + 0.0) / (sum(state_counts.merged) + sum(state_counts.closed) + sum(state_counts.open))) as merge_rate
from (
  select distinct
  gpc.creator_id,
  gpc.gplus_gender as gender,
  sum(if(gpc.state = 'merged', 1, 0)) as merged,
  sum(if(gpc.state = 'closed', 1, 0)) as closed,
  sum(if(gpc.state = 'open', 1, 0)) as open
  from ghtorrent.g_pull_closes gpc
  join (
    select distinct
    creator_id as creator_id
    from ghtorrent.g_pull_closes
    where creator_pull_index > 4
    and gplus_gender in ('Male','Female')
    and state in ('merged', 'closed', 'open')
  ) as creators on gpc.creator_id = creators.creator_id
  where
  gpc.gplus_gender in ('Male', 'Female')
  and gpc.state in ('merged', 'closed', 'open')
  group by gpc.creator_id, gpc.gplus_gender
) state_counts
group by state_counts.creator_id;
