delimiter //
drop procedure if exists associate_merger_closer;
create procedure associate_merger_closer()
begin

  declare finished bool default false;

  declare prId int;
  declare mergerCloser varchar(255);

  declare cur cursor for
  select pc.pull_request_id, pd.merger_closer
  from g_pull_closes pc
  join g_pull_descriptions pd on pd.pull_request_id = pc.pull_request_id
  where pc.state in ('merged', 'closed')
    and (pc.gplus_merger_closer_gender is null or pc.merger_closer_id is null)
    and pd.merger_closer is not null
    and pd.merger_closer <> '';

  declare continue handler
  for not found set finished = true;
  
  open cur;

  theLoop: loop

    fetch cur into prId, mergerCloser;

    if(finished) then
      leave theLoop;
    end if;

    call associate_merger_closer_(prId, mergerCloser);


  end loop theLoop;

  close cur;
end //
delimiter ;

delimiter //
drop procedure if exists associate_merger_closer_;
create procedure associate_merger_closer_(prId int, mergerCloser varchar(255))
begin
  declare mergerCloserId int;
  declare found bool default true;

  declare continue handler
  for not found set found = false;

  select id
  into mergerCloserId
  from users
  where login = mergerCloser;

  if (found) then
    update g_pull_closes pc
    set pc.gplus_merger_closer_gender =
      (
        select gender from g_gplus gp
        where gp.userId = mergerCloserId
      ),
      pc.merger_closer_id = mergerCloserId
    where pc.pull_request_id = prId;
  end if;

end //
delimiter ;


call associate_merger_closer();

drop procedure associate_merger_closer;
drop procedure associate_merger_closer_;
