-- see for description of data http://ghtorrent.org/relational.html

use ghtorrent;

-- drop table if exists g_pull_closes;
create table g_pull_closes (
  creator_id int not null, 
  pull_request_id int not null,
  -- merged, unmerged, or unassigned (null)
  close_action enum('merged', 'unmerged'),
  -- male, female, or unassigned, (null)
  gender enum('male', 'female'),
  foreign key (creator_id) references g_users (id),
  primary key (pull_request_id)
);

alter table g_pull_closes
-- member = creator_id is member of the organization which owns this repo
-- collaborator = creator_id is a collaborator added by owner of this repo
add column creator_type enum('owner', 'member', 'collaborator', 'outsider');

alter table g_pull_closes
add key (creator_type);

alter table g_pull_closes
-- for this creator, what pull number is this? (eg 1st (1), 2nd (2), 3rd (3))
add column creator_pull_index int;

alter table g_pull_closes
add key (creator_pull_index);

alter table g_pull_closes
add column creator_pull_acceptance_rate double;

-- drop bogdan gender & associate_gplus_gender.sql
alter table g_pull_closes
drop column gender;
alter table g_pull_closes
add column gplus_gender varchar(255);
alter table g_pull_closes
add key (gplus_gender);

-- drop calculated merge rate & associate_close_action.sql
-- update g_pull_closes set close_action = null;
alter table g_pull_closes
drop column close_action;
alter table g_pull_closes
add column state enum('open', 'closed', 'merged', 'unavailable', 'issue',
    '500', '404', '502');
alter table g_pull_closes
add key (state);

-- add merger_closer_gender & merger_closer_id & associate_merger_closer.sql
alter table g_pull_closes
add column gplus_merger_closer_gender varchar(255);
alter table g_pull_closes
add key (gplus_merger_closer_gender);
-- add merger_closer_id
alter table g_pull_closes
add column merger_closer_id int;

-- alter creator type to varchar
alter table g_pull_closes
modify column creator_type varchar(255);

-- add external pull index and external acceptance rate
alter table g_pull_closes
add column creator_external_pull_index int;
alter table g_pull_closes
add key (creator_external_pull_index);
alter table g_pull_closes
add column creator_external_pull_acceptance_rate double;
