/* create or replace view g_results_by_merger_closer_gender as */
/* ( */
  select pc.gplus_merger_closer_gender as merger_closer_gender,
    pc.gplus_gender as creator_gender,
    count(1) as total,
    count(if(pc.state = 'merged', 1, null)) as merged,
    count(if(pc.state = 'closed', 1, null)) as closed,
    format(0.0 + count(if(pc.state = 'merged', 1, null))/count(1), 4)
        as percent_merged
  from g_pull_closes pc
  where pc.gplus_gender in ('Male', 'Female')
    and pc.gplus_merger_closer_gender in ('Male', 'Female')
    -- there are pulls with states such as 'unavailable' if github made the
    -- pull unavailable or 404 if the pull couldn't be found (likely made
    -- private or deleted)
    and pc.state in ('merged', 'closed', 'open')
    -- only consider pulls where the pull creator is not the owner of the repo
    -- (owner), a collaborator on a personal project (collaborator) or a
    -- member of the organization (member)
    /* and pc.creator_type = '' */
    /* and pc.creator_id <> pc.merger_closer_id */
  group by pc.gplus_gender, gplus_merger_closer_gender
  order by pc.gplus_merger_closer_gender, pc.gplus_gender
/* ); */
