
select pc.gplus_gender as gender, pc.creator_pull_index as `index`,
  avg(pc.creator_pull_acceptance_rate) as avg_acceptance_rate,
  count(1) as users,
  stddev_samp(pc.creator_pull_acceptance_rate) as sample_standard_deviation
from g_pull_closes pc
where
/* pc.creator_type = '' -- outsider */
  /* and */ 
  pc.gplus_gender in ('Male', 'Female')
  and pc.creator_pull_index is not null
  and pc.creator_pull_acceptance_rate is not null
group by pc.gplus_gender, pc.creator_pull_index
order by pc.creator_pull_index asc, pc.gplus_gender;

-- for external only, uncomment this:
-- (only pulls where creator is outsider count towards acceptance rate)

-- select pc.gplus_gender as gender, pc.creator_external_pull_index as `index`,
--   avg(pc.creator_external_pull_acceptance_rate) as avg_acceptance_rate,
--   count(1) as users,
--   stddev_samp(pc.creator_external_pull_acceptance_rate)
--       as sample_standard_deviation
-- from g_pull_closes pc
-- where pc.creator_type = '' -- outsider
--   and pc.gplus_gender in ('Male', 'Female')
--   and pc.creator_external_pull_index is not null
--   and pc.creator_external_pull_acceptance_rate is not null
-- group by pc.gplus_gender, pc.creator_external_pull_index
-- order by pc.creator_external_pull_index asc, pc.gplus_gender;
