refAnalysis <- function(con){
	
	query <-  sqlImport("g_results/g_results_pull_description_references_out.sql")
	
	dbSendQuery(con, query)
	dbNextResult(con) #skip
	dbNextResult(con) #skip
	dbNextResult(con) #skip
	rs <- dbNextResult(con)
	data <- dbFetch(rs,-1)
	dbClearResult(dbListResults(con)[[1]])#close RS
	
	data <- cast(data,Gender~hasLink,sum,value="count")
	
	data <- data[order(data$`1`),]
	
	gender1row <- c(data[1,]$`1`,data[1,]$`0`)
	gender2row <- c(data[2,]$`1`,data[2,]$`0`)
	
	newcommand("neededChiSq",
			chiSqFormat(chisq.test(rbind(gender1row,gender2row))))
	
	data <- data.frame(check.names=FALSE,
			Gender = data$Gender,
			`without reference` = numberFormat(data$`0`),
			`with reference` = numberFormat(data$`1`),
			`%` = percentFormat(data$`1`/(data$`1`+data$`0`),escapePercent=FALSE),
			`95% Confidence Interval` = ciFormat(binom.confint(data$`1`,
							data$`1`+data$`0`,0.95,"exact"))
			)
	
	resultTable <- xtable(data);	
	align(resultTable) <- "ll|rrrr"
			
	newcommand(paste0("neededTable"),
			print(resultTable,
					hline.after=c(0),		
					include.rownames=FALSE,
					print.results=FALSE,
					comment=FALSE,
					floating=FALSE))
	
	return(data)
}