create table g_user_predicted_genders (
  userId int not null,
  login varchar(255) not null,
  login_male_prob decimal(2,0) default null,
  login_female_prob decimal(2,0) default null,
  key (login_male_prob),
  key (login_female_prob),
  primary key (userId)
);

insert into g_user_predicted_genders (userId, login)
select gp.userId, u.login
from g_gplus gp
join users u on u.id = gp.userId
where gender in ('Male', 'Female');

alter table g_user_predicted_genders
modify column login_male_prob int default null;
alter table g_user_predicted_genders
modify column login_female_prob int default null;

alter table g_user_predicted_genders
drop column login_male_prob;
alter table g_user_predicted_genders
drop column login_female_prob;

-- "mostly female" means more female than not, "female" is stronger
alter table g_user_predicted_genders
add column login_gender
  enum('mostly male', 'mostly female', 'male', 'female', 'unisex', 'unknown');
alter table g_user_predicted_genders
add column name_gender
  enum('mostly male', 'mostly female', 'male', 'female', 'unisex', 'unknown');

alter table g_user_predicted_genders
add column name varchar(255);
update ignore g_user_predicted_genders pg
set pg.name = (select name from users where id = pg.userId);
