var mysql = require('mysql'),
    Promise = require('promise');

var opts = {
  database: process.env.MYSQL_DATABASE,
};
if (process.env.MYSQL_PORT) opts.port = process.env.MYSQL_PORT;
if (process.env.MYSQL_HOST) opts.host = process.env.MYSQL_HOST;
if (process.env.MYSQL_PASSWORD) opts.password = process.env.MYSQL_PASSWORD;
if (process.env.MYSQL_USER) opts.user = process.env.MYSQL_USER;

var connection = mysql.createConnection(opts);

connection.connect();

var promiseQuery = Promise.denodeify(connection.query.bind(connection));

module.exports = {
  connection: connection,
  promiseQuery: promiseQuery,
};
