import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.json.JSONObject;

import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.JsonNode;
import com.mashape.unirest.http.Unirest;
import com.mashape.unirest.http.exceptions.UnirestException;
import com.mashape.unirest.request.GetRequest;


public class Test {

	private static String[] api_keys = {};//TODO insert API keys here
	
	/*
	 * Pre-req:
	 * 
	 * CREATE TABLE ghtorrent.g_project_licenses (repo_id INT NOT NULL PRIMARY KEY, license char(50)) AS 
	 *  SELECT DISTINCT repo_id,NULL AS license FROM ghtorrent.g_pull_closes2;
	 *  
	 * ALTER TABLE g_project_licenses add key (license);
	 * 
	 * Get this table from CSV, then add:
	 *  ALTER TABLE g_licenses add key (license);
	 *  
	 * These two should yield the same number:
	 * 
	 * SELECT COUNT(distinct repo_id) c FROM ghtorrent.g_pull_closes2;
	 * SELECT COUNT(repo_id) c FROM g_project_licenses;
	 */
	
	public static void main(String[] args) throws Exception {
		
		while(true){
			int successes = 0;
			for(String key : api_keys){			
				System.out.println();
				System.out.print("Running with " + key);
				successes += runWith(key);
			}
			System.out.println();
			System.out.println("Successes: " + successes);
			
			//if we ran outta requests on all of our keys, wait 10 minutes before trying again
			if(successes==0){
				System.out.println("Waiting 10 minutes before proceeding...");
				Thread.sleep(1000*60*10);
			}
		}
		
		

	}

	private static int runWith(String key) throws ClassNotFoundException,
			SQLException {
		Map<String, String> env = System.getenv();
		Class.forName("com.mysql.jdbc.Driver");
		Connection con = DriverManager.getConnection(
				"jdbc:mysql://"+env.get("MYSQL_SERVER")+":"+env.get("MYSQL_SERVER_PORT")+"/ghtorrent",
				env.get("MYSQL_USER"), env.get("MYSQL_PASSWORD"));
		
		Map<Integer,String> licenses = new HashMap<Integer, String>();
		
		//do the update later, whatever you do
		try {
			process(key, con, licenses);
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		Statement update = con.createStatement();
		for(int repo_id : licenses.keySet()){			
			update.addBatch("UPDATE g_project_licenses SET "
					+ "license='"+licenses.get(repo_id)+
					"' WHERE repo_id="+repo_id);			
		}
		update.executeBatch();
		con.close();
		
		return licenses.size();
	}

	private static void process(String key, Connection con,
			Map<Integer, String> licenses) throws SQLException {
		ResultSet results = con.createStatement().executeQuery(
				"SELECT *,repo_url(repo_id) as url FROM g_project_licenses "
						+ "WHERE license IS NULL LIMIT 5000");
		
		while(results.next()){
			int repo_id = results.getInt("repo_id");
			String repo = results.getString("url").
					replace("https://github.com/", "");
			String license = getLicense(repo,key);
			if(license==null)
				break;//probably out of requests -- get outta here
			licenses.put(repo_id, license);
			System.out.print(".");
		}
		results.close();
	}

	private static String getLicense(String repo, String key) {
		
		GetRequest r = Unirest.get("https://api.github.com/repos/"+repo+"?access_token="+key);
		r.header("Accept", "application/vnd.github.drax-preview+json");
		
		try {
			HttpResponse<JsonNode> json = r.asJson();
			int requestsRemaining = requestsRemaining(json);

			if(requestsRemaining<1){
				return null;
			}
			
			JSONObject license = json.getBody().getObject().optJSONObject("license");			
			if(license!=null){
				return license.getString("key");
			}else{
				return "none";
			}
			
		} catch (UnirestException e) {
			e.printStackTrace();
			return null;
		}		
	}

	private static int requestsRemaining(HttpResponse<?> response) {
		return Integer.valueOf((((List<?>)response.getHeaders().
				get("X-RateLimit-Remaining")).get(0).toString()));
	}
}
