-- /* This query completes in anywhere from 2-12 minutes, depending on DB temp
-- * tables, or something
select identifiable, gender, merged, open, closed,
((merged + 0.0) / (merged + closed + open)) as merge_rate 
from ((
  -- /* Get the gender-neutral users */
  select 'Gender-Neutral' as identifiable,
  sum(if(gpc.state = 'merged', 1, 0)) as merged,
  sum(if(gpc.state = 'closed', 1, 0)) as closed,
  sum(if(gpc.state = 'open', 1, 0)) as open,
  lower(gp.gender) gender
  from gender_panel_results gpr
  join g_faces gf on gf.githubUserId=gpr.userId
  join g_gplus gp on gf.userId=gp.userId
  join g_pull_closes gpc on gf.userId=gpc.creator_id
  left join sandbox.ejected_insiders ei ON gpc.pull_request_id=ei.pull_request_id
  where gpr.identifiable = 0
  and state in ('merged', 'closed', 'open')
  -- insiders; change to "not in" for outsiders
  and (gpc.creator_type in ('Owner', 'Collaborator') OR ei.earlier IS NOT NULL) 
  group by gender, identifiable
) union (
  -- /* Get the gendered users */
  select 'Gendered' as identifiable,
  sum(if(gpc.state = 'merged', 1, 0)) as merged,
  sum(if(gpc.state = 'closed', 1, 0)) as closed,
  sum(if(gpc.state = 'open', 1, 0)) as open,
  if(gupg.login_gender = 'unknown', gupg.name_gender, gupg.login_gender) gender
  from g_faces gf
  join g_gplus gp on gf.userId=gp.userId
  join g_user_predicted_genders gupg on gf.userId=gupg.userId
  join g_pull_closes gpc on gf.userId=gpc.creator_id
  left join sandbox.ejected_insiders ei ON gpc.pull_request_id=ei.pull_request_id
  where gpc.state in ('merged', 'closed', 'open')
  and gf.identicon = 0
  and if(gupg.login_gender = 'unknown', gupg.name_gender, gupg.login_gender) in ('female', 'male')
  and if(gupg.login_gender = 'unknown', gupg.name_gender, gupg.login_gender) = lower(gp.gender)
  -- insiders; change to "not in" for outsiders
  and (gpc.creator_type in ('Owner', 'Collaborator') OR ei.earlier IS NOT NULL)
  group by if(gupg.login_gender = 'unknown', gupg.name_gender, gupg.login_gender), identifiable
)) as state_counts;
