// Usage: node get_file_types.js pull_request_ids.txt

var rl = require('readline')
var fs = require('fs')
var cheerio = require('cheerio')

// Pull request id file
var lineReader = rl.createInterface({
  terminal: false,
  input: fs.createReadStream(process.argv[2])
});

// Process each PR ID
lineReader.on('line', function(line){
  pr_id = line.trim();
  filename = '/media/prs/pulls/' + pr_id + '.html';
  // filename = pr_id + '.html';
  data = fs.readFileSync(filename);
  $ = cheerio.load(data);
  files_changed = $('#toc ol li').map(function(e,v) {
    return $(v).find('a').eq(1).text().match(/[\w\.]+$/) + ':' + ($(v).find('a').eq(0).attr('aria-label').match(/\d+/) || 0);
  }).toArray();
  console.log('' + pr_id + ',[' + files_changed.join(',').toString() + ']');
});
