// Usage: node get_file_types.js [ids.in]

var rl = require('readline')
var fs = require('fs')
var cheerio = require('cheerio')

// Pull request id file
ids_filename = process.argv[2] == undefined ? "ids.in" : process.argv[2];
var lineReader = rl.createInterface({
  terminal: false,
  input: fs.createReadStream(ids_filename)
});

// Process each PR ID
lineReader.on('line', function(line){
  line_arr = line.trim().split("\t");
  if (line_arr[0] != 'gplus_gender') {
    pr_id = line_arr[2];
    // filename = '/media/prs/pulls/' + pr_id + '.html';
    filename = pr_id + '.html';
    data = fs.readFileSync(filename);
    $ = cheerio.load(data);
    lines_changed = $('#toc ol li').map(function(e,v) {
      return parseInt($(v).find('a').eq(0).attr('aria-label').match(/\d+/) || 0);
    }).toArray();
    files_changed = $('#toc ol li').map(function(e,v) {
      return $(v).find('a').eq(1).text().match(/[\w\.]+$/);
    }).toArray();
    extensions_changed = {};
    $(files_changed).each(function(i, file) {
      extension = file.match(/\.\w+$/);
      extensions_changed[extension] = extensions_changed[extension] == undefined ? lines_changed[i] : extensions_changed[extension] + lines_changed[i];
    });
    console.log(extensions_changed);
    // max_lines_changed = Math.max.apply(Math, lines_changed);
    // if (files_changed.length > 0) {
    //   console.log(line_arr[0] + ',' + line_arr[1] + ',' + pr_id + ',[' + files_changed[lines_changed.indexOf(max_lines_changed)] + ':' + max_lines_changed + ']');
    // }
  }
});
