select
  gpc.pull_request_id,
  state,
  gender,
  lines_added,
  lines_deleted,
  commit_count,
  files_changed,
  IF(earlier IS NULL,creator_type,'Collaborator') creator_type,
  identicon,
  references_from,
  references_to,
  extension,
  creator_pull_index,
  license,
  identifiable 
from g_pull_closes2 gpc LEFT JOIN sandbox.ejected_insiders ei ON gpc.pull_request_id=ei.pull_request_id
where state in ('merged', 'closed', 'open')
  and gender in ('male', 'female')
  and lines_added is not null
  and lines_deleted is not null
  and net_lines_added is not null
  and commit_count is not null
  and files_changed is not null
  and creator_type is not null
  and identicon is not null
  and references_from is not null
  and references_to is not null
  and creator_pull_index is not null
  and license is not null
  and extension is not null
  and extension!='none'
  and extension!='null'