create temporary table sandbox.mp(PRIMARY KEY (pull_request_id)) as 
select distinct pull_request_id from pull_request_history
where action='merged';

create table sandbox.merge_report(PRIMARY KEY (pull_request_id)) as 
(select pull_request_id, MAX(isMerged) as isMerged FROM 
(SELECT 
    pr.id as pull_request_id, if(mp.pull_request_id IS NOT NULL,1,pc.commit_id IS NOT NULL) as isMerged 
FROM 
    pull_requests pr 
        LEFT JOIN 
    commit_parents cp ON pr.head_commit_id = cp.parent_id 
        LEFT JOIN 
    project_commits pc ON cp.commit_id = pc.commit_id 
        AND pc.project_id = pr.base_repo_id 
        LEFT JOIN 
    sandbox.mp mp ON mp.pull_request_id=pr.id) as whatevs 
GROUP BY pull_request_id);
